/*
	ShuchanUITCh(tfBXvC{{^)

	|[g
		PA0	out	duU[
		PA1	out	NC
		PB0	in	XCb`A(_EvAbv)
		PB1	in	XCb`B(_EvAbv)
		PB2	in	XCb`C(_EvAbv)
		PB3	out	LCDRgXgAiOo(PWM)(OC1A)
		PB4	out	LCDobNCgON/OFFo(PWM)(OC1B)
		PB5	in	DI
		PB6	out	DO
		PB7	in	USCK
		PD0	io	LCD-DB4
		PD1	io	LCD-DB5
		PD2	io	LCD-DB6
		PD3	io	LCD-DB7
		PD4	out	LCD-E
		PD5	out	LCD-RW	(ǎg킸ɏ݂0ɂĂ)
		PD6	out	LCD-RS

	ʐMvgR
		\n؂ƂAR}h𑗐MB
		R}hPC烁Cւ̒ʐMƓ悤ł邪A؂蕶\tƂB
		XCb`Ԃ̑M
			SW-A=1, B=2, C=4ƂĐl\AxƂB
			x + (x << 4) + 0x80𑗐MB

*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdlib.h>
#include <string.h>
#include "lcddriver.h"

void LCDInit(void);
void LCDInit_SetMode(uint8_t data);
void LCDSendByte(uint8_t data, uint8_t mode);
uint8_t LCDIsBusy(void);
void LCDClear(void);
void LCDSetPos(uint8_t addr);
void LCDPutStr(char *s);
#define RECV_BUFFER_SIZE 16
//PC̃R}hĂƂ0ȊOB
uint8_t SPI_IsDataReceived(void);
//R}h擾B
char SPI_ReadCmd(void);
//R}h̎̈ǂݏoB
char* SPI_ReadNextArg(void);
//R}h̎̈ǂݏoA8bitȂɕϊB
uint8_t SPI_ReadNextArgUINT8(void);
//R}h̎̈ǂݏoA8bit萮ɕϊB
int8_t SPI_ReadNextArgINT8(void);
//R}h̎̈ǂݏoA16bit萮ɕϊB
int16_t SPI_ReadNextArgINT16(void);
//R}hIƂɌĂԁB
void SPI_CmdReset(void);


volatile uint8_t pdout = 0;
#define NSW 3
#define SWOFFTHRES 64
#define SWONTHRES 192
volatile uint8_t SWValue[NSW];	//XCb`̐ϕl
volatile uint8_t SWState[NSW];	//XCb`On(1)/Off(0)
volatile uint8_t ovfFlag = 0;	//^C}[荞݂ŃI[o[t[Ƃ1ɂB
#define RECV_BUFFER_SIZE 16

ISR(TIMER0_OVF_vect)
{
	ovfFlag = 1;
}

#define SPIRECVSTATE_CMDRECVING (_BV(0))	//R}hMrB
#define SPIRECVSTATE_CMDCOMPLETE (_BV(1))	//R}hMB
#define SPIRECVSTATE_CMDPROCESSING (_BV(2))	//R}hvOB
#define SPLITCHAR '\t'	//R}ḧ̋؂蕶B

volatile char recvbuf[RECV_BUFFER_SIZE];
volatile char* nextarg = 0;	//̈̐擪ւ̃|C^B
volatile uint8_t recvptr = 0;	//ɏނׂrecvbuf̃CfbNXB
volatile uint8_t recvstate = 0;	//MԁB
volatile uint8_t swstateresponse = 0;	//CɑMAXCb`ԁB

ISR(USI_OVERFLOW_vect)
{
	USISR = _BV(USIOIF);
	char rcvdchar = USIDR;
	USIDR = swstateresponse;
	//obt@TCY𒴂ȂƁER}hłȂƂmF
	if(!(recvstate & SPIRECVSTATE_CMDPROCESSING))
	{
		switch(rcvdchar)
		{
			case '\r':
			case '\0':
				//CR, NULL͖
				break;
			case '\n':
				//s=R}h̏I
				recvstate = SPIRECVSTATE_CMDCOMPLETE;
				break;
			default:
				//M
				//obt@ӂȂ͈͂Œǉ
				if(recvptr < RECV_BUFFER_SIZE)
				{
					recvstate = SPIRECVSTATE_CMDRECVING;
					if(rcvdchar == 0xFF)
					{
						rcvdchar = ' ';	//0xFFXy[XɒuB
					}
					recvbuf[recvptr++] = rcvdchar;
				}
				else
				{
					//obt@I[o[t[h~
				}
				break;
		}
	}
}

int main(void)
{
	DDRA = 0b00000011;
	DDRB = 0b01011000;
	PORTB = 0b00000111;
	DDRD = 0x7F;
	PORTD = 0;

	OCR1A = 50;
	OCR1B = 250;
	TCCR1A = _BV(COM1A1) | _BV(COM1B1) | _BV(WGM10);
	TCCR1B = _BV(WGM12) | _BV(CS10);

	TCCR0B = _BV(CS01) | _BV(CS00);	//clk / 64 = 488/s荞
	TIMSK = _BV(TOIE0);

	USICR = _BV(USIWM0) | _BV(USIOIE) | _BV(USICS1);
	USISR = _BV(USIOIF);

	lcd_init(); 							/*LCD*/
	lcd_position(0,0);						/*J[\ʒu̐ݒ*/
	lcd_put_str("ޯ ");		/*̕\*/
	lcd_position(0,3);						/*J[\ʒu̐ݒ*/
	lcd_put_str("2008 NAREC, ROR'Dan");					/*̕\*/
	lcd_position(0,0);

	sei();

	while(1)
	{
		if(ovfFlag)
		{
			ovfFlag = 0;
			for(uint8_t i = 0; i < NSW; i++)
			{
				SWValue[i] = SWValue[i] / 4 * 3;
			}

			for(uint8_t i = 0; i < NSW; i++)
			{
				if(PINB & _BV(i))
				{
					SWValue[i] += 64;
				}
			}

			for(uint8_t i = 0; i < NSW; i++)
			{
				if(SWValue[i] > SWONTHRES)
				{
					SWState[i] = 0;	//|[gĤƂOnƂۂL̂ƂĂ̂łŏB
				}
				else if(SWValue[i] < SWOFFTHRES)
				{
					SWState[i] = 1;
				}
			}

			uint8_t resp = 0;

			for(uint8_t i = 0; i < NSW; i++)
			{
				resp += SWState[i] << i;
			}

			swstateresponse = resp | (resp << 4) | 0x80;

			//XCb`ԕ\eXg
			/*
			lcd_clear();
			lcd_position(5,3);
			char buf[8];
			itoa(swstateresponse, buf, 16);
			lcd_put_str(buf);
			*/
		}

		if(SPI_IsDataReceived())
		{
			uint8_t iscmdreset = 0;
			char txtbuf[RECV_BUFFER_SIZE];
			switch(SPI_ReadCmd())
			{
				case 'a':
					{
						uint8_t x, y;
						x = SPI_ReadNextArgUINT8();
						y = SPI_ReadNextArgUINT8();
						SPI_CmdReset();
						iscmdreset = 1;
						lcd_position(x, y);
					}
					break;
				case 'd':
					{
						uint8_t line = SPI_ReadNextArgUINT8();
						SPI_CmdReset();
						iscmdreset = 1;
						lcd_position(0, line);
						lcd_put_str("                    ");
					}
					break;
				case 't':
					strcpy(txtbuf, SPI_ReadNextArg());
					SPI_CmdReset();
					iscmdreset = 1;
					lcd_put_str(txtbuf);
					break;
				case 'f':
					SPI_CmdReset();
					iscmdreset = 1;
					lcd_clear();
					break;
				case 'c':
					OCR1A = SPI_ReadNextArgUINT8();
					SPI_CmdReset();
					iscmdreset = 1;
					break;
				case 'b':
					OCR1B = SPI_ReadNextArgUINT8();
					SPI_CmdReset();
					iscmdreset = 1;
					break;
				case 's':
					{
						cli();
						int16_t beeplong = SPI_ReadNextArgINT16();
						uint8_t waitlongorg = SPI_ReadNextArgUINT8();
						SPI_CmdReset();
						iscmdreset = 1;
						uint8_t waitlong = 0;
						while(beeplong--)
						{
							PORTA = PORTA ^ _BV(0);
							waitlong = waitlongorg;
							while(waitlong--)
							{
								_delay_us(1);
							}
						}
						sei();
						break;
					}
			}
			if(!iscmdreset)
			{
				SPI_CmdReset();
			}
		}

	}
}

uint8_t SPI_IsDataReceived(void)
{
	return recvstate & SPIRECVSTATE_CMDCOMPLETE;
}

char SPI_ReadCmd(void)
{
	if(recvptr == 0)
	{
		return '\0';
	}

	recvbuf[recvptr] = '\0';	//I[LtĂ
	nextarg = &(recvbuf[1]);
	if(*nextarg == 0)
	{
		nextarg = 0;	//Ȃ
	}
	return recvbuf[0];
}

char* SPI_ReadNextArg(void)
{
	char* currentarg = nextarg;
	if(currentarg == 0)
	{
		//͐sĂB
		return currentarg;
	}

	//ŏɏoĂXy[XnullɒuAnextarg̎̕ɐݒ肷B
	while(1)
	{
		nextarg++;
		if(*nextarg == SPLITCHAR)
		{
			//Xy[X̂ŁA܂ł̈B
			*nextarg = '\0';
			nextarg++;
			break;
		}

		if(*nextarg == '\0')
		{
			//R}h̖B܂ł̈ŁA͂ȂB
			nextarg = 0;
			break;
		}
	}

	return currentarg;
}

uint8_t SPI_ReadNextArgUINT8(void)
{
	char* arg = SPI_ReadNextArg();
	if(arg == 0)
	{
		return 0;
	}
	return (uint8_t)atoi(arg);
}

int8_t SPI_ReadNextArgINT8(void)
{
	char* arg = SPI_ReadNextArg();
	if(arg == 0)
	{
		return 0;
	}
	return (int8_t)atoi(arg);
}

int16_t SPI_ReadNextArgINT16(void)
{
	char* arg = SPI_ReadNextArg();
	if(arg == 0)
	{
		return 0;
	}
	return (int16_t)atoi(arg);
}

void SPI_CmdReset(void)
{
	nextarg = 0;
	recvstate = 0;
	recvptr = 0;
}
